#! /bin/bash
#
### BEGIN INIT INFO
# Provides: wallace
# Default-Start:     2 3 4 5
# Default-Stop:      0 1 6
# Required-Start: $remote_fs $local_fs $network
# Required-Stop: $remote_fs $local_fs $network
# Short-Description: Start/Stop the Kolab Server daemon
# Description:      The Kolab Wallace server daemon is a content filtering daemon.
### END INIT INFO

PATH=/sbin:/usr/sbin:/bin:/usr/bin
DESC="The Kolab Wallace server daemon is a content filtering daemon" # Introduce a short description here
NAME=wallace                        # Introduce the short server's name here
PROG_NAME=wallaced
DAEMON=/usr/sbin/$PROG_NAME           # Introduce the server's location here
DAEMON_ARGS="--fork -l warning"     # Arguments to run the daemon with
PIDFILE=/run//$PROG_NAME/$PROG_NAME.pid
LOCKFILE=/run/lock/$PROG_NAME
SCRIPTNAME=/etc/init.d/$NAME
DEFAULTSFILE=/etc/default/$NAME
USER="kolab"
GROUP="kolab-n"

# Read configuration variable file if it is present
[ -r /etc/default/$NAME ] && . /etc/default/$NAME

# Load the VERBOSE setting and other rcS variables
. /lib/init/vars.sh

# Define LSB log_* functions.
# Depend on lsb-base (>= 3.0-6) to ensure that this file is present.
. /lib/lsb/init-functions

#
# Function that starts the daemon/service
#
do_start()
{
    # Return
    #   0 if daemon has been started
    #   1 if daemon was already running
    #   2 if daemon could not be started

    # If the daemon is not enabled, give the user a warning and stop.
    if [ "$START" != "yes" ]; then
        log_warning_msg "To enable $NAME, edit $DEFAULTSFILE and set START=yes"
        return 0
    fi

    # Make sure the pid directory is there
    if [ ! -d /run/$PROG_NAME ]; then
      mkdir /run/$PROG_NAME
    fi
    chown $USER:$GROUP /run/$PROG_NAME

    start-stop-daemon \
        --start \
        --quiet \
        --pidfile $PIDFILE \
        --startas $DAEMON \
        --test > /dev/null \
        || return 1
    start-stop-daemon \
        --start \
        --quiet \
        --pidfile $PIDFILE \
        --startas $DAEMON \
        -- $FLAGS $DAEMON_ARGS \
        || return 2
    # Add code here, if necessary, that waits for the process to be ready
    # to handle requests from services started subsequently which depend
    # on this one.  As a last resort, sleep for some time.
    touch $LOCKFILE
}

#
# Function that stops the daemon/service
#
do_stop()
{
    # Return
    #   0 if daemon has been stopped
    #   1 if daemon was already stopped
    #   2 if daemon could not be stopped
    #   other if a failure occurred
    start-stop-daemon \
          --stop \
          --quiet \
          --retry=TERM/30/KILL/5 \
          --user $USER \
          --startas $DAEMON \
          --pidfile $PIDFILE \
          --name $PROG_NAME
    RETVAL="$?"
    [ "$RETVAL" = 2 ] && return 2
    # Wait for children to finish too if this is a daemon that forks
    # and if the daemon is only ever run from this initscript.
    # If the above conditions are not satisfied then add some other code
    # that waits for the process to drop all resources that could be
    # needed by services started subsequently.  A last resort is to
    # sleep for some time.
    start-stop-daemon --stop --quiet --oknodo --retry=0/30/KILL/5 --exec $DAEMON
    [ "$?" = 2 ] && return 2
    # Many daemons don't delete their pidfiles when they exit.
    rm -f $PIDFILE
    rm -f $LOCKFILE
    return "$RETVAL"
}

case "$1" in
  start)
    [ "$VERBOSE" != no ] && log_daemon_msg "Starting $DESC " "$NAME"
    do_start
    case "$?" in
        0|1) [ "$VERBOSE" != no ] && log_end_msg 0 ;;
        2) [ "$VERBOSE" != no ] && log_end_msg 1 ;;
    esac
  ;;
  stop)
    [ "$VERBOSE" != no ] && log_daemon_msg "Stopping $DESC" "$NAME"
    do_stop
    case "$?" in
        0|1) [ "$VERBOSE" != no ] && log_end_msg 0 ;;
        2) [ "$VERBOSE" != no ] && log_end_msg 1 ;;
    esac
    ;;
  status)
       status_of_proc "$DAEMON" "$NAME" && exit 0 || exit $?
       ;;
  restart|force-reload)
    log_daemon_msg "Restarting $DESC" "$NAME"
    do_stop
    case "$?" in
      0|1)
        do_start
        case "$?" in
            0) log_end_msg 0 ;;
            1) log_end_msg 1 ;; # Old process is still running
            *) log_end_msg 1 ;; # Failed to start
        esac
        ;;
      *)
          # Failed to stop
        log_end_msg 1
        ;;
    esac
    ;;
  *)
    #echo "Usage: $SCRIPTNAME {start|stop|restart|reload|force-reload}" >&2
    echo "Usage: $SCRIPTNAME {start|stop|status|restart|force-reload}" >&2
    exit 3
    ;;
esac

:
